SystemOrganization addCategory: #CS528!

Object subclass: #GameServer
	instanceVariableNames: 'connectionSocket isRunning isRunningLock numConnections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528'!

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:14'!
initialize
	super initialize.
	isRunningLock := Mutex new.
	self isRunning: false.
	numConnections := 0
	! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:56'!
interactOnConnection
	| interactionSocket |
	interactionSocket := connectionSocket waitForAcceptFor: 1 ifTimedOut: [^self].
	[self interactUsing: interactionSocket] fork! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 18:15'!
interactUsing: interactionSocket
	| player receivedData gb |
		
	[ 
	numConnections := numConnections + 1.
	player := GameObject new.
	gb := self setupGameBoard: player.
	gb openInWindow.
	receivedData := ''.
	[interactionSocket isConnected ] whileTrue:  [  
		[receivedData := interactionSocket receiveData.
		receivedData crLog.
		(receivedData = 'left') ifTrue: [gb moveGameObjectLeft: player]
		] on: ConnectionTimedOut
		do: [].
	]. 
	] ensure: [
	interactionSocket closeAndDestroy ]
! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:52'!
isRunning
	^ isRunningLock critical: [ isRunning ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:53'!
isRunning: aBoolean
	isRunningLock critical: [ isRunning := aBoolean ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:16'!
numConnections
	^numConnections ! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:14'!
numConnections: aNum
	numConnections := aNum! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:58'!
serve
	[ [ self isRunning ]
	whileTrue: [ self interactOnConnection ] ]
	ensure: [ connectionSocket closeAndDestroy ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 16:53'!
setupGameBoard
	^(GameBoard boardSize: 8 windowSize: 400) 
	at: 6 at: 2 addGameObject: (GameObject new)! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 18:13'!
setupGameBoard: aPlayer
	^(GameBoard boardSize: 10 windowSize: 400) 
	at: 6 at: 2 addGameObject: (aPlayer)! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:57'!
start
	isRunningLock critical: [
	self isRunning ifTrue: [ ^ self ].
	self isRunning: true].
	connectionSocket := Socket newTCP.
	connectionSocket listenOn: 9999 backlogSize: 10.
	[ self serve ] fork! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:55'!
stop
	self isRunning: false! !
